﻿@inject IUsersRepository UsersRepository

<MudSelect T="UserEntity" @bind-Value="@SelectedUser" Label="@(new UserEntity().GetDisplayName(u => u.FullName))" HelperText="@HelperText">
    <MudSelectItem T="UserEntity" Value="null">@("")</MudSelectItem>
    @foreach (UserEntity user in _users)
    {
        <MudSelectItem T="UserEntity" Value="user">@(user.FullName)</MudSelectItem>
    }
</MudSelect>

@code {
    [Parameter]
    public string HelperText { get; set; } = string.Empty;

    private UserEntity _selectedUser;

    [Parameter]
    public UserEntity SelectedUser
    {
        get => _selectedUser;

        set
        {
            if (_selectedUser == null)
            {
                if (value == null) return;
            }
            else
            {
                if (_selectedUser.Equals(value)) return;
            }

            _selectedUser = value;
            SelectedUserChanged.InvokeAsync(value);

            SelectedUserId = _selectedUser == null ? null : _selectedUser.Id;
            SelectedUserIdChanged.InvokeAsync(SelectedUserId);
        }
    }
    [Parameter]
    public int? SelectedUserId { get; set; }

    [Parameter]
    public EventCallback<UserEntity> SelectedUserChanged { get; set; }
    [Parameter]
    public EventCallback<int?> SelectedUserIdChanged { get; set; }

    private IEnumerable<UserEntity> _users = new List<UserEntity>();

    protected override async Task OnInitializedAsync()
    {
        _users = await UsersRepository.GetAllUsers();
    }
}